defmodule ExMP4 do
  @moduledoc File.read!("README.md")

  @type timescale :: Ratio.t() | integer()
  @type offset :: integer()
  @type duration :: non_neg_integer()

  def t() do
    {:ok, reader} =
      ExMP4.Reader.new("/home/ghilas/Downloads/Video/Love Like the Galaxy Part 2 Episode 1.mp4")

    %{sample_table: sample_table} = List.first(ExMP4.Reader.tracks(reader))

    {:suspended, acc, fun} =
      Enumerable.reduce(sample_table, {:cont, []}, fn elem, _acc ->
        {:suspend, elem}
      end)

    do_iterate(fun, acc)
  end

  def do_iterate(fun, acc) do
    with {:suspended, acc, fun} <- fun.({:cont, acc}) do
      IO.inspect(acc)
      do_iterate(fun, acc)
    end
  end

  def test() do
    {:ok, reader} =
      ExMP4.Reader.new("/home/ghilas/Downloads/Video/Love Like the Galaxy Part 2 Episode 1.mp4")

    {:ok, writer} = ExMP4.Writer.new("test.mp4")

    tracks = ExMP4.Reader.tracks(reader)

    writer = ExMP4.Writer.write_header(writer)

    {_track1, writer} = ExMP4.Writer.add_track(writer, Enum.at(tracks, 0))
    {_track2, writer} = ExMP4.Writer.add_track(writer, Enum.at(tracks, 1))

    writer =
      ExMP4.Reader.stream(reader)
      |> Enum.reduce(writer, fn sample, writer ->
        ExMP4.Writer.write_sample(writer, sample.track_id, sample)
      end)

    # writer =
    #   Enum.reduce(1..track.sample_count, writer, fn sample_id, writer ->
    #     sample = ExMP4.Reader.read_sample(reader, track.id, sample_id - 1)
    #     ExMP4.Writer.write_sample(writer, track_id, sample)
    #     # IO.inspect({time, time2})
    #     # writer
    #   end)

    ExMP4.Writer.write_trailer(writer)
  end
end
